<?php

require_once("mapi/mapi.util.php");
require_once("mapi/mapidefs.php");
require_once("mapi/mapitags.php");


$server = "http://localhost:236/zarafa";
$zarafa = false;
$specialprops = array(
		"fileas" 		=> "PT_STRING8:{00062004-0000-0000-C000-000000000046}:0x8005",
		"email1" 		=> "PT_STRING8:{00062004-0000-0000-C000-000000000046}:0x8083",
		"business_street"	=> "PT_STRING8:{00062004-0000-0000-C000-000000000046}:0x8045",
		"business_postcode"	=> "PT_STRING8:{00062004-0000-0000-C000-000000000046}:0x8048",
		"business_city"		=> "PT_STRING8:{00062004-0000-0000-C000-000000000046}:0x8046",
		"business_state"	=> "PT_STRING8:{00062004-0000-0000-C000-000000000046}:0x8047",
		"business_country"	=> "PT_STRING8:{00062004-0000-0000-C000-000000000046}:0x8049"
		);

function toUTF8($str) {
	return str_replace('&#039;', '&apos;', htmlspecialchars(utf8_encode($str), ENT_QUOTES));
}

function open_zarafa($session) {
	$ret = array("root" => "/");

	$storesTable = mapi_getmsgstorestable($session);
	$stores = mapi_table_queryallrows($storesTable, array(PR_ENTRYID, PR_MDB_PROVIDER));
	for($i = 0;$i < count($stores); $i++){
		if ($stores[$i][PR_MDB_PROVIDER] == ZARAFA_SERVICE_GUID){
			$storeEntryid = $stores[$i][PR_ENTRYID];
			break;
		}
	}

	if (!isset($storeEntryid))
		trigger_error("Default store not found", PR_USER_ERROR);


	$store = mapi_openmsgstore($session, $storeEntryid);
	$root = mapi_msgstore_openentry($store, null);
	$rootProps = mapi_getprops($root, array(PR_IPM_CONTACT_ENTRYID));

	$folder = mapi_msgstore_openentry($store, $rootProps[PR_IPM_CONTACT_ENTRYID]);

	$table = mapi_folder_getcontentstable($folder);

	$contacts = mapi_table_queryallrows($table);

	$ret["session"] = $session;
	$ret["store"] = $store;
	$ret["contacts"] = $contacts;
	return $ret;
}

function xmlcontactinfo($contactprops) {
	$output = "<Contact>\n";

	//// GENERAL INFORMATION
	$output .= "\t<FirstName>" . toUTF8($contactprops[PR_SURNAME])    . "</FirstName>\n"; 
	$output .= "\t<LastName>"  . toUTF8($contactprops[PR_GIVEN_NAME]) . "</LastName>\n";

	//// PHONE NUMBERS
	$v = $contactprops[PR_HOME_TELEPHONE_NUMBER	]; if ($v){ $output .= "\t<Phone><phonenumber>" . toUTF8($v) . "</phonenumber></Phone>\n"; }
	$v = $contactprops[PR_BUSINESS_TELEPHONE_NUMBER	]; if ($v){ $output .= "\t<Phone><phonenumber>" . toUTF8($v) . "</phonenumber></Phone>\n"; }
	$v = $contactprops[PR_HOME2_TELEPHONE_NUMBER	]; if ($v){ $output .= "\t<Phone><phonenumber>" . toUTF8($v) . "</phonenumber></Phone>\n"; }
	$v = $contactprops[PR_BUSINESS2_TELEPHONE_NUMBER]; if ($v){ $output .= "\t<Phone><phonenumber>" . toUTF8($v) . "</phonenumber></Phone>\n"; }
	$v = $contactprops[PR_MOBILE_TELEPHONE_NUMBER	]; if ($v){ $output .= "\t<Phone><phonenumber>" . toUTF8($v) . "</phonenumber></Phone>\n"; }
	$v = $contactprops[PR_HOME_FAX_NUMBER		]; if ($v){ $output .= "\t<Phone><phonenumber>" . toUTF8($v) . "</phonenumber></Phone>\n"; }
	$v = $contactprops[PR_BUSINESS_FAX_NUMBER	]; if ($v){ $output .= "\t<Phone><phonenumber>" . toUTF8($v) . "</phonenumber></Phone>\n"; }
	$v = $contactprops[PR_OTHER_TELEPHONE_NUMBER	]; if ($v){ $output .= "\t<Phone><phonenumber>" . toUTF8($v) . "</phonenumber></Phone>\n"; }

	$output .= "</Contact>\n";
	return $output;
}

if (!isset($_SERVER['PHP_AUTH_USER'])) {
	header('WWW-Authenticate: Basic realm="Zarafa XML Phonebook"');
	header('HTTP/1.0 401 Unauthorized');
	echo 'You need to login to download your phonebook';
	exit;
} else {
	$user = $_SERVER['PHP_AUTH_USER'];
	$pass = $_SERVER['PHP_AUTH_PW'];

	$session = mapi_logon_zarafa($user, $pass, $server);
	if (false != $session) {
		$zarafa = open_zarafa($session);
		$zarafa['user'] = $user;

		$specialprops = getPropIdsFromStrings($zarafa["store"], $specialprops);
	} else {
		header("HTTP/1.0 404 Not Found");
		echo("Could not log on to zarafa");
		exit;
	}

	$store = $zarafa["store"];
	$contacts = $zarafa["contacts"];

	$output = "<?xml version=\"1.0\"?><AddressBook><version>1</version>\n";

	foreach ($contacts as $contact) {
		$message = mapi_msgstore_openentry($store, $contact[PR_ENTRYID]);
		$props = mapi_getprops($message);
		$output .= xmlcontactinfo($props);
	}

	$output .= "</AddressBook>\n";

	header('Content-type: text/xml');
	echo($output);

}

?>
